//Form styling
@import '~@mod-publisher/js/forms/styles';
@import '../config';

$color_default: #4a4a4a;
$color_error: #D50000;
$color_disabled: #BFBFBF;
$bgcolor_disabled: #F2F2F2;
$color_candybar: rgba(26, 125, 215, 0.6);

$label_leftspace: 195px;
$onecolumntogglewidth: 550px;

@at-root
{
  @include wh-form-flex; //Use flex layout
}

::-webkit-input-placeholder { opacity: 0.7; color: inherit;}
::-moz-placeholder { opacity: 0.7; color: inherit;}
:-ms-input-placeholder { opacity: 0.7; color: inherit;}
input:-moz-placeholder { opacity: 0.7; color: inherit;}

.rpc__busyoverlay
{
  display: none;
  z-index: 10000;
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0,0,0,0.5);

  html.dompack--busymodal &
  {
    display: block;
  }

  .spinner
  {
    display: block;
    position: absolute;
    color: #fff;
    font-size: 80px;
    top: 50%;
    left: 50%;
    margin-top: -40px;
    margin-left: -40px;
    opacity: 0.8;
  }
}

.wh-form__richtext .centercontent
{
  padding-right: 0;
  padding-left: 0;
}

.wh-form.wh-styledinput
{
  h3
  {
    font-size: 21px;
  }

  .wh-form__fieldgroup
  {
    margin-bottom: 15px;
  }

    .wh-form__fieldgroup--required > .wh-form__label::after
  , .wh-form__fieldgroup--required .wh-form__label:empty + .wh-form__fields .wh-form__optionlabel::after
  {
    display: inline-block;
    content: "*";
  }

  .wh-form__prefix
  {
    padding-right: 10px;
    align-self: center;
  }

  .wh-form__suffix
  {
    padding-left: 10px;
    align-self: center;
  }

    .wh-form__optionlabel
  , .wh-form__subfield > label
  {
    padding-right: 15px;
  }

  .wh-form__label:empty::after
  {
    display: none;
  }

  .wh-form__fieldgroup > .wh-form__label
  {
    flex: 0 0 $label_leftspace;
    max-width: $label_leftspace;
    min-width: $label_leftspace;
  }

  .wh-form__fieldgroup > .wh-form__fields
  {
    max-width: calc(100% - #{$label_leftspace});
  }

  .wh-form__fieldgroup--richtext > .wh-form__fields
  {
    max-width: 100%;
  }

  @media (max-width: $onecolumntogglewidth)
  {
    .wh-form__fieldgroup //order the vertical inputs below their labels
    {
      -ms-flex-direction: column;
      -webkit-flex-direction: column;
      flex-direction: column;
      align-items: flex-start;

      & > .wh-form__label
      {
        padding-bottom: 3px;
      }

      .wh-form__subfield
      {
        flex-wrap: wrap;
      }

        & > .wh-form__label
      , & > .wh-form__fields
      {
        flex: none;
        max-width: calc(100vw - 40px);
        min-width: 0;
      }
    }
    .wh-form__fields //and give fields the full width
    {
      width:100%;
    }
  }


    select + .wh-form__subfield > label
  , .wh-form__pulldown-styled + .wh-form__subfield > label
  {
    padding-left: 10px;
  }

    input
  , select:not(.wh-rtd__toolbarstyle)
  , textarea
  , .wh-form__imgedit
  , .wh-form__dateinputgroup
  , .wh-form__timeinputgroup
  {
    border: 1px solid $color_default;
    min-height: 44px;
    font-family: inherit;
    font-size: 16px;
    line-height: 20px;
    padding: 11px 15px;
    max-width: 100%;
    color: inherit;
    flex: 1;
    border-radius: 0;
    background-color: #fff;
    outline: none;
    -webkit-appearance: none;
    -moz-appearance: none;
    -o-appearance: none;
    appearance: none;

    &:disabled, &[data-wh-form-disabled]
    {
      color: $color_disabled;
      border-color: $color_disabled;
      background-color: $bgcolor_disabled;
      box-shadow: none;
    }
  }

  .wh-form__fieldgroup--upload
  {
    .wh-form__uploadfield
    {
      display: flex;
      flex-direction: row;
      width: 100%;
      justify-content: space-between;
      position: relative;
    }

    .wh-form__uploadfielddelete
    {
      background-color: transparent;
      height: 100%;
      align-items: center;
      padding-right: 5px;
      cursor: pointer;

      &::after
      {
        width: 20px;
        height: 20px;
        color: $color_default;
        font-weight: 900;
        border-radius: 50%;
        background-color: #fff;
        font-size: 20px;
        font-family: "Font Awesome 5 Free";
        content: "\f057";
      }
    }

    .wh-form__uploadfield--hasfile .wh-form__uploadfielddelete
    {
      display: flex;
    }

    .wh-form__uploadfieldinputholder
    {
      display: block;
      flex-grow: 100;
      position: relative;

      input
      {
        width: 100%;
      }
    }

    .wh-form__uploadfieldselect
    {
      margin-left: 15px;
    }
  }

  .wh-form--uploading .wh-form__uploadfieldfilename
  {
    background-image: linear-gradient(
      135deg,
      $color_candybar 16.67%,
      transparent 16.67%,
      transparent 50%,
      $color_candybar 50%,
      $color_candybar 66.67%,
      transparent 66.67%
    );
    background-size: 84.85px 84.85px;
    animation: movebackground 2s linear infinite;
  }

  .wh-form__imgedit
  {
    width: 150px;
    height: 200px;
    padding: 0;
    flex: none;

    &::after
    {
      display: flex;
      font-family: "Font Awesome 5 Free";
      content: "\f382"; /* cloud */
      font-weight: 700;
      font-size: 33px;
      align-items: center;
      justify-content: center;
      background-image: none;
      padding-bottom: 40px;
      color: #4A4A4A;
    }

    .wh-form__imgeditdelete
    {
      position: absolute;
      width: 20px;
      height: 20px;
      top: 5px;
      right: 10px;
      background-color: transparent;
      cursor: pointer;

      &::before
      {
        width: 20px;
        height: 20px;
        color: $color_default;
        font-weight: 900;
        border-radius: 50%;
        background-color: #fff;
        font-size: 20px;
        font-family: "Font Awesome 5 Free";
        content: "\f057";
      }
    }

    .wh-form__imgeditholder::before
    {
      display: block;
      position: absolute;
      text-align: center;
      font-size: 15px;
      color: $color_default;
      bottom: 0;
      left: 0;
      padding: 20px;
      content: "Drop or upload an image";
    }

    &--hasimage
    {
        &::after
      , .wh-form__imgeditholder::before
      {
        display: none;
      }
    }

    &[data-wh-form-disabled]::after
    {
      opacity: 0.2;
    }

    &[data-wh-form-disabled] .wh-form__imgeditholder
    {
      display: none;
    }
  }

  .wh-form__imgeditholder::after
  {
    z-index: 1;
    content: "\f1ce";
    display: inline-block;
    position: absolute;
    display: none;
    width: 80px;
    top: 50%;
    left: 50%;
    height: 80px;
    font-size: 80px;
    line-height: 80px;
    font-weight: 900;
    font-family: "Font Awesome 5 Free";
    color: $color_default;
    margin-top: -40px;
    margin-left: -40px;
    opacity: 0.8;
    -webkit-animation: fa-spin 2s infinite linear;
    animation: fa-spin 2s infinite linear;
  }
  .wh-form--uploading
  {
    .wh-form__imgeditholder::after
    {
      display: inline-block;
    }
        .wh-form__imgedit::after
      , .wh-form__imgedit .wh-form__imgeditholder::before
      {
        display: none;
      }
  }

  textarea
  {
    min-height: 140px;
  }

  .wh-rtd__editor
  {
    width: 100%;
    min-height: 200px;

    .wh-rtd__stylescope
    {
      padding: 5px 8px;
    }

    .wh-rtd-toolbar select
    {
      height: 23px;
      border-color: #aaa;
      border-radius: 1px;
      font-size: 15px;
      padding: 0 10px;
      min-height: 22px;
    }
  }

  .wh-form__fieldgroup--error
  {
      input
    , select
    , textarea
    , .wh-form__imgedit
    , .wh-form__dateinputgroup
    , .wh-form__timeinputgroup
    {
      border-color: $color_error;
    }
  }

  .wh-form__error
  {
    display: none;
    flex: none;
    width: 100%; /* force error text below item */
    color: $color_error;
    padding: 8px 0 0;
  }

  .wh-form__fieldgroup--error .wh-form__error
  {
    display: block;
  }

    .wh-form__fieldgroup--radiogroup .wh-form__fieldline
  , .wh-form__fieldgroup--checkboxgroup .wh-form__fieldline
  {
    align-items: baseline;
  }

  /* css styled pulldown */
  .wh-form__pulldown-styled
  {
    position: relative;
    flex: 1;

    select
    {
      padding-right: 35px;
      width: 100%;

      &:disabled
      {
        opacity: 0.4;

        & + .arrow
        {
          opacity: 0.4;
        }
      }
    }

    select::-ms-expand
    {
      display: none; /* hide select arrow in IE */
    }

    .arrow
    {
      font-size: 22px;
      position: absolute;
      right: 15px;
      top: 50%;
      color: $color_default;
      margin-top: -10px;
      pointer-events: none;
    }

    select[disabled] + .arrow
    {
      opacity: 0.2;
    }

    &:after /* overflow right mask */
    {
      display: block;
      content: "";
      width: 25px;
      position: absolute;
      z-index: 2;/* On top of select */
      right: 28px;
      top: 3px;
      bottom: 3px;
      pointer-events: none;

      background: -moz-linear-gradient(left, rgba(255,255,255,0) 0%, rgba(255,255,255,1) 100%); /* FF3.6-15 */
      background: -webkit-linear-gradient(left, rgba(255,255,255,0) 0%,rgba(255,255,255,1) 100%); /* Chrome10-25,Safari5.1-6 */
      background: linear-gradient(to right, rgba(255,255,255,0) 0%,rgba(255,255,255,1) 100%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
      filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#00ffffff', endColorstr='#ffffff',GradientType=1 ); /* IE6-9 */
    }
  }


  /* radio / checkbox styling */

    input[type='radio']
  , input[type='checkbox']
  {
    display  : block;
    position : absolute;
    left     : -9999px;
    width    : 0px;
    height   : 0px;

    & + label
    {
      vertical-align: top;
      cursor: pointer;
      position: relative;
      top: 3px;
      width: 20px;
      max-width: 20px;
      flex: 0 0 20px;
      height: 20px;
      border: 1px solid $color_default;
      background-color: #fff;

      &::after
      {
        font-family: "Font Awesome 5 Free";
        content: '';
        font-weight: 700;
        position: absolute;
        top: 0;
        left: 0;
        color: $color_default;
        font-size: 14px;
        display: block;
        padding: 1px 0 0 2px;
        width: 100%;
        height: 100%;
        line-height: 16px;
        transition: all 0.3s;
      }
    }

    &[disabled]
    {
      & + label
      {
        border-color: $color_disabled;
        cursor: default;
      }

      & + label + *
      {
        color: $color_default;
      }
    }
  }

    .wh-form__fieldgroup--radiogroup .wh-form__fieldline + .wh-form__fieldline
  , .wh-form__fieldgroup--checkboxgroup .wh-form__fieldline + .wh-form__fieldline
  {
    margin-top: 10px;
  }

  .wh-form__optiondata > *
  {
    padding-left: 15px;
  }

  .wh-form__optiondata--horizontal
  {
    margin-right: 30px;
    width: 100%;

    &:last-child
    {
      margin-right: 0;
    }
  }

  .wh-form__fieldgroup--horizontal
  {
    & > .wh-form__fields
    {
      margin-left: -20px;

      & > .wh-form__fieldline
      {
        padding-left: 20px;
      }
    }

    .wh-form__fieldline--nowrap
    {
      margin-top: 10px;
    }
  }

  input[type='radio']
  {
    & + label
    {
      border-radius: 50%;
    }

    & + label::after
    {
      border: 3px solid #fff;
      border-radius: 50%;
    }

    &:checked + label::after
    {
      background-color: $color_default;
    }

    &[disabled] + label::after
    {
      background-color: $bgcolor_disabled;
      border-color: $bgcolor_disabled;
    }

    &[disabled]:checked + label::after
    {
      background-color: $color_disabled;
    }
  }

  input[type='checkbox']
  {
    &:checked + label::after
    {
      content: '\f00c';
      color: $color_default;
    }

    &[disabled] + label::after
    {
      content: '';
    }

    &[disabled] + label
    {
      background-color: $bgcolor_disabled;
    }

    &[disabled]:checked + label::after
    {
      content: '\f00c';
      color: $color_disabled;
    }
  }

    .wh-form__fieldgroup--error input[type='checkbox']:not(:checked) + label
  , .wh-form__fieldgroup--error input[type='radio']:not(:checked) + label
  {
    border-color: $color_error;
  }

  .wh-form__button
  {
    cursor: pointer;
    text-transform: uppercase;
    height: 44px;
    outline: none;
    -webkit-appearance: none;
    text-decoration: none;
    white-space: nowrap;
    box-shadow: none;
    overflow: visible; /* IE fix */
    text-align: left;
    font-size: 16px;
    line-height: 20px;
    padding: 11px 15px;
    background-color: $primarycolor;
    color: #fff;
    border: 0 none;
    transition: opacity 0.3s;
    position: relative;
    border-radius: 3px;
  }

  .wh-form__buttongroup
  {
    text-align: right;
    margin-top: 30px;
    border-top: 1px solid #c5c5c5;
    padding: 20px 0;

    &::after
    {
      content: "";
      display: block;
      clear: both;
    }

    .wh-form__button
    {
      min-width: 200px;
      padding-right: 35px;

      &::after
      {
        display: inline-block;
        font-family: "Font Awesome 5 Free";
        content: "\f105";
        font-weight: 900;
        font-size: 22px;
        position: absolute;
        right: 15px;
        top: 50%;
        margin-top: -10px;

      }

      &:hover
      {
        opacity: 0.8;
      }

      & + .wh-form__button
      {
        margin-left: 15px;
      }

      &--previous
      {
        float: left;
        background-color: #fff;
        border: 1px solid $color_default;
        color: $color_default;
        padding-right: 15px;
        padding-left: 35px;

        &::after
        {
          right: auto;
          left: 15px;
          content: "\f104";
        }

        &:hover
        {
          background-color: #fff;
          box-shadow: 1px 1px 4px 0 rgba(0,0,0,0.25);
        }
      }
    }
  }
}

@keyframes movebackground {
  0% {
    background-position: 0 0;
  }
  100% {
    background-position: 84.85px 84.85px;
  }
}
